__exactly_even_and_zero__mod__3(o).
__exactly_odd_and_two__mod__3(s(X1)) :- __exactly_even_and_one__mod__3(X1).
__exactly_odd_and_zero__mod__3(s(X1)) :- __exactly_even_and_tree__3n__plus__2(X1).
__exactly_odd_and_one__mod__3(s(X1)) :- __exactly_even_and_zero__mod__3(X1).
__exactly_even_and_zero__mod__3(s(X1)) :- __exactly_odd_and_two__mod__3(X1).
__exactly_even_and_one__mod__3(s(X1)) :- __exactly_odd_and_zero__mod__3(X1).
__exactly_even_and_tree__3n__plus__2(s(X1)) :- __exactly_odd_and_one__mod__3(X1).
__exactly_list__even_and_tree__3n__plus__2(nil).
__exactly_list__even_and_tree__3n__plus__2(cons(X1,X2)) :- __exactly_even_and_tree__3n__plus__2(X1), __exactly_list__even_and_tree__3n__plus__2(X2).
__exactly_r (X1,X2) :- __exactly_odd_and_two__mod__3(X1), __exactly_list__even_and_tree__3n__plus__2(X2).
